SystemOrganization addCategory: #'SOUL-LogicPrimitives'!

LogicStorage subclass: #DeprecatedPredicatesLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!DeprecatedPredicatesLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
fooXbarXselXM3

foo: bla bar: test sel: goo! !

!DeprecatedPredicatesLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
linksToXM2

(?fromFeature ?edge: ?toFeatures) linksTo: ?feature if 
	(?fromFeature ?edge: ?toFeatures) isFeatureEdgeSetFrom: ?fromFeature,?toFeatures contains: ?feature! !

LogicStorage subclass: #LogicPrimitives
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!LogicPrimitives commentStamp: '<historical>' prior: 0!
This class contains primitive logic predicates such as those provided by most Prolog dialects.

These predicates are deliberately NOT a part of LiCoR, our library for code reasoning, since they are not specific for reasoning about code.
!

LogicPrimitives subclass: #ArithmeticLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
add1M2

"tested on 02-07-2001"

add1(?N,?Nplus1) if 
	sub1(?Nplus1,?N)! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
addM3

"tested on 02-07-2001"

add(?N,?M,?NplusM) if 
	sub(?NplusM,?N,?M)! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
comparableM2

"tested on 02-07-2001"

comparable(?N,?M) if 
	[(?N isKindOf: Magnitude) and: [?M isKindOf: Magnitude]]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
greaterM2

"tested on 02-07-2001"

greater(?N,?M) if 
	comparable(?N,?M),[?N > ?M]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
greaterOrEqualM2

"tested on 02-07-2001"

greaterOrEqual(?N,?M) if 
	comparable(?N,?M),[?N >= ?M]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
integerM1

"tested on 02-07-2001

integer(+?N) tests whether ?N is a Smalltalk integer like -1, 2, 0, 7 etc.
	 Note that real numbers representing integers, like 4.0, will NOT be considered
	 as integers by this predicate!! Also note that the predicate fails when called
	 with a variable."

integer(?N) if 
	[?N isInteger]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
numberM1

"tested on 02-07-2001"

number(?N) if 
	[?N isKindOf: Number]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
positiveIntegerM1

"tested on 02-07-2001

positiveInteger(+?N) tests whether ?N is a positive Smalltalk integer like 1, 2, 3, ... etc.
	 0 is also considered as a positive integer.
	 Note that real numbers representing integers, like 4.0, will NOT be considered
	 as positive integers by this predicate!! Also note that the predicate fails when called
	 with a variable."

positiveInteger(?N) if 
	integer(?N),greaterOrEqual(?N,[0])! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
productM3

product(?N,?M,?NtimesM) if 
	atom(?N),var(?M),atom(?NtimesM),equals(?M,[?NtimesM / ?N]).
product(?N,?M,?NtimesM) if 
	var(?N),atom(?M),atom(?NtimesM),equals(?N,[?NtimesM / ?M]).
product(?N,?M,?NtimesM) if 
	atom(?N),atom(?M),var(?NtimesM),equals(?NtimesM,[?N * ?M]).
product(?N,?M,?NtimesM) if 
	atom(?N),atom(?M),atom(?NtimesM),equals(?NtimesM,[?N * ?M])! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
smallerM2

"tested on 02-07-2001"

smaller(?N,?M) if 
	comparable(?N,?M),[?N < ?M]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
smallerOrEqualM2

"tested on 02-07-2001"

smallerOrEqual(?N,?M) if 
	comparable(?N,?M),[?N <= ?M]! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
strictPositiveIntegerM1

"tested on 02-07-2001

strictPositiveInteger(+?N) tests whether ?N is a strict positive Smalltalk integer
	 like 1, 2, 3, ... etc. 0 is NOT considered as a strict positive integer.
	 Note that real numbers representing integers, like 4.0, will NOT be considered
	 as strict positive integers by this predicate!! Also note that the predicate fails
	 when called with a variable."

strictPositiveInteger(?N) if 
	integer(?N),greater(?N,[0])! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
sub1M2

"tested on 02-07-2001"

sub1(?N,?Nminus1) if 
	var(?N),atom(?Nminus1),equals(?N,[?Nminus1 + 1]).
sub1(?N,?Nminus1) if 
	atom(?N),var(?Nminus1),equals(?Nminus1,[?N - 1]).
sub1(?N,?Nminus1) if 
	atom(?N),atom(?Nminus1),equals(?Nminus1,[?N - 1])! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
subM3

"tested on 02-07-2001"

sub(?N,?M,?NminusM) if 
	atom(?N),var(?M),atom(?NminusM),equals(?M,[?N - ?NminusM]).
sub(?N,?M,?NminusM) if 
	var(?N),atom(?M),atom(?NminusM),equals(?N,[?M + ?NminusM]).
sub(?N,?M,?NminusM) if 
	atom(?N),atom(?M),var(?NminusM),equals(?NminusM,[?N - ?M]).
sub(?N,?M,?NminusM) if 
	atom(?N),atom(?M),atom(?NminusM),equals(?NminusM,[?N - ?M])! !

!ArithmeticLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
zeroM1

"tested on 02-07-2001"

zero([0])! !

LogicPrimitives subclass: #DataHandlingLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
appendAtomsM3

"appendAtoms/3(+?A1,+?A2,+-?A3) concatenates 2 atoms or strings ?A1 and ?A2 into a third ?A3"

appendAtoms(?Atom1,?Atom2,?Atom3) if 
	atom(?Atom1),atom(?Atom2),equals(?Atom3,[(?Atom1 , ?Atom2) asSymbol]).
appendAtoms(?Atom1,?Atom2,?Atom3) if 
	not(and(atom(?Atom1),atom(?Atom2))),error(['appendAtoms/3 requires the two first arguments to be atoms!!'])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
appendM3

"append/3 join or split lists

tested

append(?First, ?Second, ?Whole) (where ?First, ?Second and ?Whole are either lists or variables) joins or split lists.
If ?First and ?Second are instantiated, the ?Second list is appended to the end of the ?First list to give the ?Whole list.
If ?First, ?Second and ?Whole are instantiated, then test that the ?Whole list begins with the ?First list and that the remainder of the ?Whole list is the ?Second list.
If ?First and ?Whole are instantiated and the ?Whole list starts with the ?First list, then the remainder of the ?Whole list is returned as ?Second.
If ?Second and ?Whole are instantiated and the ?Whole list ends with the ?Second list then the beginning of the ?Whole list is returned as ?First.
If ?Whole is instantiated, the ?Whole list is  split at an arbitrary place to form two new sub-lists ?First and ?Second. Alternative solutions will be provided on backtracking."

append(<>,?List,?List).
append(<?ElFirst|?RestFirst>,?Second,<?ElFirst|?Rest>) if 
	append(?RestFirst,?Second,?Rest)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:55'!
assertM1

"assert(+?Term) asserts a clause (i.e., a fact or rule) that is given as a logic ?Term"

assert(&term) if 
	getRepository(?repository),getEnv(?env,?),[?repository
	addClause:
		(Fact
			condition:
				(SoulFactory current makeTermSequence terms: OrderedCollection new)
			conclusion: &term)]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:55'!
assertM2

"assert(+?Term,+?Repository) asserts a clause (i.e., a fact or rule) that is given as a logic ?Term
	 in a certain logic ?Repository"

assert(&term,?aRepository) if 
	getEnv(?env,?),[?aRepository
	addClause:
		(Fact
			condition:
				(SoulFactory current makeTermSequence terms: OrderedCollection new)
			conclusion: &term)]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
atomM1

"atom(?Term) succeeds if, and only if, ?Term is instantiated to a SOUL atom
	 (including the special atom denoting the empty list)"

atom(&Term) if 
	[(&Term isKindOf: UppedObject) | (&Term isKindOf: SmalltalkTerm)]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
atomToCharsM2

"atomToChars(+?Atom, +-?CharList) transforms an ?Atom to a ?CharList. The current implementation only works when ?Atom is bound to an atom. ?CharList on the other hand may or may not be variable.

CASE 1: atomToChars(+?Atom, -?CharList)"

atomToChars(?Atom,?CharList) if 
	atom(?Atom),var(?CharList),stringOrAtomToChars(?Atom,?CharList).
"CASE 2: atomToChars(+?Atom, +?CharList)"

atomToChars(?Atom,?CharList) if 
	atom(?Atom),nonvar(?CharList),atomToChars(?Atom,?AtomAsCharList),equals(?CharList,?AtomAsCharList)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
compoundM1

"tested by KM on 2002/04/04

compound(+-?Term) tests for a compound term. It succeeds if ?Term is a compound term and fails otherwise."

compound(&Term) if 
	[&Term isKindOf: CompoundTerm]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
concatQuotedTermsM3

"concatQuotedTerms(?ListOfQuotedTerms,?Separator, ?QuotedTerm) turns a ?ListOfQuotedTerms 
	 into a ?QuotedTerm with all those ?QuotedTerms in the order in which they
	 appear in the list separated by a ?Separator. No extra ?Separator at the end is
	 produced.

Note: a variant of this predicate that works on strings instead of quoted code terms is listAsSeparatedString/3

Special case: needed for when the empty list is passed as argument."

concatQuotedTerms(<>,?,{}).
"Ordinary Cases"

concatQuotedTerms(<?QuotedTerm>,?Separator,{?QuotedTerm}).
concatQuotedTerms(<?QuotedTerm|?OtherQuotedTerms>,?Separator,{?QuotedTerm?Separator?Rest}) if 
	nonEmptyList(?OtherQuotedTerms),concatQuotedTerms(?OtherQuotedTerms,?Separator,?Rest)! !

!DataHandlingLayer methodsFor: 'collections and lists' stamp: 'sp 24/10/11 15:26'!
containsXM2

?c contains: ?e if 
	member(?e,?c)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
counterincrM1

"This predicate has a non-decarative semantics, it is meant mostly for writing test cases were there's a need to test the number of times a query is executed for example."

counterincr(+?x) if 
	[?x
	at: 1
	put: (?x at: 1) + 1.
true].
counterincr(-?x) if 
	equals(?x,[Array with: 1])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
countervalueM2

countervalue(-?counter,?value) if 
	equals(?counter,[Array with: ?value]).
countervalue(+?counter,?value) if 
	equals(?value,[?counter at: 1])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
deepflattenM2

"tested on 09-07-2001

deepflatten(+?ListOfNestedLists,+-?List) transforms a list of lists (which can again contain
	 lists, and so on) to a single list containing all elements of each of the sublists of the
	 original list of lists, in the same order. The list of nested lists that is provided as input
	 is supposed to be instantiated."

deepflatten(<>,<>).
deepflatten(?Item,<?Item>) if 
	not(list(?Item)).
deepflatten(?ListOfNestedLists,?List) if 
	nonvar(?ListOfNestedLists),equals(?ListOfNestedLists,<?First|?Rest>),deepflatten(?First,?FlatFirst),deepflatten(?Rest,?FlatRest),append(?FlatFirst,?FlatRest,?List)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
differenceM3

"converted on 2001-11-30 by Tom Mens

tested

calculates the set difference"

difference(?Set1,?Set2,?Diff) if 
	findall(?El,and(includes(?El,?Set1),not(includes(?El,?Set2))),?Diff)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
differsM2

"tested on 08-07-2001

differs(?X,?Y) is the opposite of equals(?X,?Y)
	 and verifies whether ?X and ?Y are NOT unifiable"

differs(?El1,?El2) if 
	not(equals(?El1,?El2))! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
disjointM2

"tested on 22/08/2001

disjoint(+?Set1,+?Set2) verifies whether two sets ?Set1 and ?Set2 are disjoint.
	 Both ?Set1 and ?Set2 are supposed to be instantiated."

disjoint(?Set1,?Set2) if 
	forall(includes(?El,?Set1),not(includes(?El,?Set2)))! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
elGroundMemberM2

elGroundMember(?El,<?El|?Rest>).
elGroundMember(?El,<?First|?Rest>) if 
	not(equals(?First,?El)),elGroundMember(?El,?Rest)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
elNotGroundMemberM2

elNotGroundMember(?El,<?El|?Rest>).
elNotGroundMember(?El,<?First|?Rest>) if 
	elNotGroundMember(?El,?Rest)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
emptyListM1

"tested on 09-07-2001"

emptyList(<>)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
endsWithM2

"tested on 10/09/2001

endsWith(+?String,+?Postfix) checks whether a given ?String ends with some ?Postfix
	 Both arguments are supposed to be instantiated upon calling this predicate. Warning:
	 the predicate is case-INsensitive, in other words it makes no distinction between capitals
	 and non-capitals when comparing strings.

Implementation note: the reason for the case-insensitivity has to do with the lower-level
	 Smalltalk primitive (i.e. #match:) that was used to implement this predicate. It was no
	 deliberate design decision for the predicate."

endsWith(?AString,?APostfix) if 
	or(var(?AString),var(?APostfix)),error(['endsWith/2 was called with one or both arguments variable!!']).
endsWith(?AString,?APostfix) if 
	['*' , ?APostfix match: ?AString]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
equalsM2

"tested on 08-07-2001

equals/2 tries to unify two terms. If this is unsuccesful, the result is false.
	 If it is successful, the necessary bindings will have been added to the environment."

equals(?X,?X)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:56'!
equalsStructureListM2

"=..

equalsStructureList(?Term, ?List) is the SOUL equivalent of the Prolog construct =.. and
	 defines the relationship between a compound ?Term and a ?List.

	?List is a list whose first element is the principal functor of the ?Term, and whose tail
	is the list of arguments of ?Term.

	If ?Term is an uninstantiated variable, then ?List must be a list with instantiated head.
	A compound term will be constructed from the list. The functor of the term will be the head of the list, 
	while the arguments of the term will be the tail of the list.

	If ?Term is not a variable, then the corresponding list is constructed and unified with ?List

	If ?Term is not compound but just a symbol, then it unifies with a list containing just that symbol.

CASE 0: ?Term is not compound term but just a symbol"

equalsStructureList(?Term,<?Term>) if 
	symbol(?Term).
"CASE 1a: ?Term is an uninstantiated variable and ?List is a list with instantiated head"

equalsStructureList(?Term,<?head|?rest>) if 
	var(?Term),atom(?head),not([?head = ListTerm ListTermFunctor smalltalkValue]),subStructureList(?collection,?rest,?termPointerList,0),getEnv(?env,?),getRepository(?rep),envLookup(?Term,?TermPointer),length(?termPointerList,?length),[| newCollection newTerm count startIndex |
newCollection := OrderedCollection new.
count := 0.
startIndex := ?env startUnify: ?length + 1.
?termPointerList
	listDo:
		[:aVarPointer | 
		var := (Variable name: 'temp') setAddress: count.
		newCollection add: var.
		var
			unifyWith: aVarPointer smalltalkValue term
			inEnv: ?env
			myIndex: startIndex
			hisIndex: aVarPointer smalltalkValue envIndex
			inSource: false.
		count := count + 1].
?head = ListTerm ListTermFunctor smalltalkValue
	ifTrue:
		[self halt.
		newCollection add: EmptyListConstant new.
		newTerm := SoulFactory current makeList new makeListCompound: newCollection]
	ifFalse:
		[newTerm := SoulFactory current makeCompound
			functor: ?head soulUp
			termSequence: (TermSequence terms: newCollection)
			astLink: ((HiddenVariable name: SoulFactory uniqueName) setAddress: ?length)].
newTerm definitionRepository: ?rep.
?TermPointer term
	unifyWith: newTerm
	inEnv: ?env
	myIndex: ?TermPointer envIndex
	hisIndex: startIndex
	inSource: true.
true].
"CASE 1b: The head is list-functor"

equalsStructureList(?Term,<?head,?car,?cdr>) if 
	var(?Term),atom(?head),[?head = ListTerm ListTermFunctor smalltalkValue],equals(?Term,<?car|?cdr>).
"CASE 2: ?Term is not a variable but a compound term"

equalsStructureList(?Term,?List) if 
	compound(?Term),envLookup(?List,?ListPointer),envLookup(?Term,?TermPointer),getEnv(?env,?),[| listTerm |
listTerm := ListTerm
	termSequence:
		((OrderedCollection new)
			add: ?Term functor;
			addAll: ?Term termSequence terms;
			yourself).
?ListPointer term
	unifyWith: listTerm
	inEnv: ?env
	myIndex: ?ListPointer envIndex
	hisIndex: ?TermPointer envIndex
	inSource: true]! !

!DataHandlingLayer methodsFor: 'comparing' stamp: 'sp 24/10/11 15:26'!
equalsXM2

?x equals: ?x! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
flattenM2

"tested on 22/08/2001

flatten(+?ListOfLists,+-?List) transforms a list of lists to a single list containing all
	 elements of each of the sublists of the original list of lists, in the same order.
	 The list of lists is supposed to be instantiated. The flattened list can either be
	 instantiated or not."

flatten(<>,<>).
flatten(<?First|?Rest>,?Result) if 
	flatten(?Rest,?FlatRest),append(?First,?FlatRest,?Result)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
groundM1

"tested on 05-07-2001

ground(+-?Term) succeeds if ?Term is currently instantiated to a term that is completely 
	 bound (has no uninstantiated variables in it); otherwise it fails"

ground(&X) if 
	[| result varVisitor |
result := true.
varVisitor := AllButHiddenVariablesVisitor
	doBlock: [:var | result := false].
&X accept: varVisitor.
result]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
headM2

"tested on 22/08/2001

head(+-?Element,+?List) unifies ?Element with the first element of ?List.
	 ?Element can either be instantiated or not. ?List should be instantiated,
	 although it may be only instantiated partially."

head(?First,<?First|?Rest>)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
includesM2

"tested on 27/08/2001

includes(+-?Element, +?Set) is the equivalent for sets of member/2 which works on lists.
	 (But since we represents sets as list too, includes/2 is directly implemented in 
	 terms of member/2.) The first argument ?Element can either be instantiated or not,
	 the second argument ?Set must be instantiated upon calling the predicate."

includes(?Element,?Set) if 
	member(?Element,?Set)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
intersectionListsM2

"tested

Get a list with the common elements in a list of lists. For example:
		intersectionLists(<<[1],[2],[42]>,<[2],[3],[42]>,<[3],[4],[42]>>, <[42]>)

Passing variables as lists, or even variables within the lists, is NOT allowed."

intersectionLists(?lists,?intersectionList) if 
	forall(member(?list,?lists),ground(?list)),privateIntersectionLists(?lists,?intersectionList)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
intersectionM3

"tested on 22/08/2001

intersection(+?Set1,+?Set2,+-?Intersection) computes the ?Intersection of two sets ?Set1 and
	 ?Set2. Both ?Set1 and ?Set2 are supposed to be instantiated. ?Intersection can either be
	 instantiated or not. It contains the computed intersection. The order of the elements in
	 the intersection will be the same as the order in which the corresponding elements
	 appear in ?Set1"

intersection(?Set1,?Set2,?Intersection) if 
	findall(?El,and(includes(?El,?Set1),includes(?El,?Set2)),?Intersection)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
lastMemberOfXM2

?last lastMemberOf: <?last>.
?last lastMemberOf: <?|?rest> if 
	?last lastMemberOf: ?rest! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
lengthM2

"partially converted

tested

only works if the list if a real list, does not work when list is a variable

get the length of a list
 If Term is a list, Length will be unified with the number of items in the list. 
 If Length is an integer and Term is unbound, Term will be unified with a list of 
 variables of the specified Length."

length(<>,[0]).
length(<?car|?cdr>,-?length) if 
	length(?cdr,?x),equals(?length,[?x + 1]).
"Warning: ?l of length(?l, 3) may print as <?car, ?car, ?car>, but the ?car named variables are distinct in reality"

length(<?car|?cdr>,+?length) if 
	[?length > 0],length(?cdr,[?length - 1])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
listAsSeparatedStringM3

"listAsSeparatedString(?ListOfSymbols,?Separator, ?String) turns a ?ListOfSymbols (or
	 strings) into a ?String with all those symbols in the order in which they
	 appear in the list separated by a ?Separator. No extra ?Separator at the end is
	 produced.

Note: a variant for this predicate that works on quoted terms instead of symbols/strings is concatQuotedTerms/3.

Special case: needed for when the empty list is passed as argument."

listAsSeparatedString(<>,?,['']).
"Base case: stop without a space if the list just contains one single element."

listAsSeparatedString(<?el>,?,[?el asString]).
"Recursive case: take the first element followed by a space, followed by a
	 the other elements."

listAsSeparatedString(<?el|?rest>,?Separator,?string) if 
	not(emptyList(?rest)),listAsSeparatedString(?rest,?Separator,?reststring),equals(?string,[?el asString , ?Separator , ?reststring])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
listM1

list(&term) if 
	[(&term isKindOf: ListTerm) | (&term isKindOf: EmptyListConstant)]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
listMemberM2

listMember(?El,?List) if 
	ground(?El),elGroundMember(?El,?List).
listMember(?El,?List) if 
	nonground(?El),list(?List),elNotGroundMember(?El,?List)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
makeFirstCapitalLowerCaseM2

"Soul.SoulTests.DataHandlingTest run: #testmakeFirstCapitalLowerCase

makeFirstCapitalLowerCase(+?String,+-?NewString) transforms a ?String into a new one where
 the first characted is converted into a lower case one (if it was already a lower case one, the new
 string is just a copy of the old one"

makeFirstCapitalLowerCase(?String,?NewString) if 
	string(?String),equals(?NewString,[| x |
x := ?String copy.
x
	at: 1
	put: x first asLowercase.
x])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
mapM3

"sequential call of the predicate on the lists, with element of first list as first arg and element of second list as second arg"

map(<>,<>,?).
map(<?elfirst|?restfirst>,<?elsecond|?restsecond>,?predicate) if 
	?predicate(?elfirst,?elsecond),map(?restfirst,?restsecond,?predicate)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
memberM2

"tested on 28/08/2001

member(+-?Element,+-?List) gets or checks a member of a list. If ?Element is instantiated,
	 member/2 will check that it is a member of the list ?List (if ?List is a variable, it will be bound
 	 to a list that contains ?Element). If ?Element is a variable, it will be bound to the first element
	 of ?List. On backtracking, it will be bound to successive elements of ?List.

	 Usage note: As opposed to the implementation of member/2 in Prolog, the predicate will fail 
	 when both ?Element and ?List are variable!!"

member(?El,+?Collection) if 
	[?Collection isKindOf: Collection],collectionMember(?El,?Collection).
member(?El,?List) if 
	or(list(?List),var(?List)),listMember(?El,?List)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
noDupsM2

"tested on 22/08/2001

noDups(+?ListWithDuplicates,+-?ListWithoutDuplicates) checks whether ?ListWithoutDuplicates
	 is the same (up to a permutation of its elements) as ?ListWithDuplicates after all of its
	 duplicate elements have been removed. The ?ListWithDuplicates is supposed to be instantiated.
	 The ?ListWithoutDuplicates can either be instantiated, or it can be uninstantiated in which
	 case the appropriate value will be generated for it."

noDups(+?listWithDuplicates,?noDupsList) if 
	var(?noDupsList),nonvar(?listWithDuplicates),listAsCollection(?listWithDuplicates,?withDuplicates),listAsCollection(?noDupsList,[?withDuplicates asSet]).
noDups(+?listWithDuplicates,+?noDupsList) if 
	nonvar(?noDupsList),nonvar(?listWithDuplicates),listAsCollection(?listWithDuplicates,?withDuplicates),listAsCollection(?noDupsList,?noDups),[| result withDuplicatesRemoved |
withDuplicatesRemoved := ?withDuplicates asSet.
result := withDuplicatesRemoved size = ?noDups size
	and: [?noDups allSatisfy: [:each | withDuplicatesRemoved includes: each]].
result]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
nonEmptyListM1

"tested on 28/08/2001

nonEmptyList(+?List) checks whether ?List is a non-empty list. The argument is supposed
	 to be instantiated.

Implementation note: the order of the predicants in the rule below is important."

nonEmptyList(?List) if 
	var(?List),error(['nonEmptyList/1 was called with a variable argument!!']).
nonEmptyList(?List) if 
	not(emptyList(?List)),list(?List)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
nongroundM1

"tested on 21/08/2001

nonground(?Term) states that the argument ?Term is non-ground, 
	 i.e. contains at least one unbound variable."

nonground(?Term) if 
	not(ground(?Term))! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
nonvarM1

"tested on 21/08/2001

nonvar(+-?Term) succeeds if, and only if, Term is instantiated. It is the opposite of var/1"

nonvar(?Term) if 
	not(var(?Term))! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
privateIntersectionListsM2

privateIntersectionLists(<?first|?rest>,?intersectedList) if 
	list(?first),list(?rest),privateIntersectionListsRecursion(?first,?rest,?intersectedList)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
privateIntersectionListsRecursionM3

"intersect the first argument (with the already intersected lists) with the first
	element of the ones to do (the head of the second argument). Then do a recursive step.
	When the recursion returns, ?intersection will have the result"

privateIntersectionListsRecursion(?done,<?todoFirst|?todoRest>,?intersection) if 
	intersection(?done,?todoFirst,?intersectedFirst),privateIntersectionListsRecursion(?intersectedFirst,?todoRest,?intersection).
"stop condition: nothing more to do (the second list), so the resulting intersection is in ?L.
	Assign this as the solution. Because we are now at the deepest  recursin level,
	we will now rise again to the top, passing the result in the last variable"

privateIntersectionListsRecursion(?L,<>,?L)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
quotedCodeM1

quotedCode(&term) if 
	[&term isKindOf: QuotedCodeTerm]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
removeAuxM3

removeAux(<?X|?L>,?X,?L).
removeAux(<?Y|?L1>,?X,<?Y|?L2>) if 
	not(equals(?X,?Y)),removeAux(?L1,?X,?L2)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
removeM3

"tested on 28/08/2001

remove(+-?List,+-?Element,+-?ListWithoutElement) removes the first occurence of
	 ?Element from a list ?List and yields a new list ?ListWithoutElement. If ?List is variable,
	 the ?Element will be inserted somewhere in ?ListWithoutElement. It is assumed that
	 at least one of the lists is non-variable when calling the predicate."

remove(?List,?Element,?ListWithoutElement) if 
	and(var(?List),var(?ListWithoutElement)),error(['remove/3 was called with two variable lists!!']).
remove(?List,?Element,?ListWithoutElement) if 
	removeAux(?List,?Element,?ListWithoutElement)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
retractM1

"not tested

retract(+?Term)  retracts the first occurence of a clause with a given head ?Term from the default logic repository"

retract(&term) if 
	nonvar(&term),getRepository(?repository),getEnv(?env,?),[?repository
	retract: (&term predicateInEnv: ?env startAt: nil)
	multiplicity: &term multiplicity]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
retractMatchM1

"retractMatch(+?Term) retracts all occurence of a clause of which the head unifies with ?Term"

retractMatch(&term) if 
	nonvar(&term),getRepository(?repository),getEnv(?env,?),envLookup(&term,?index),[| clauses result |
result := false.
clauses := ?repository
	clausesForKey: (&term predicateKeyInEnv: ?env startAt: nil)
	ifAbsent: [#()].
clauses
	do:
		[:aClause | 
		| i |
		i := ?env startUnifyWith: aClause.
		(&term
			unifyWith: aClause conclusion
			inEnv: ?env
			myIndex: ?index
			hisIndex: i
			inSource: true)
			ifTrue:
				[?repository removeClause: aClause.
				result := true].
		?env rollback].
result]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
retractMatchM2

"retractMatch(+?Term,+?conditionPredicate) retracts all occurence of a clause of which the head unifies with ?Term"

retractMatch(&term,&conditionPredicate) if 
	nonvar(&term),nonvar(&conditionPredicate),getRepository(?repository),getEnv(?env,?),envLookup(&term,?termPointer),collectionMember(?clause,[| clauses result i |
result := OrderedCollection new.
clauses := ?repository
	clausesForKey: (&term predicateKeyInEnv: ?env startAt: nil)
	ifAbsent: [#()].
clauses
	do:
		[:aClause | 
		i := ?env startUnifyWith: aClause.
		(?termPointer term
			unifyWith: aClause conclusion
			inEnv: ?env
			myIndex: ?termPointer envIndex
			hisIndex: i
			inSource: true) ifTrue: [result add: aClause].
		?env rollback].
result]),apply(&conditionPredicate,<?clause>),[?repository removeClause: ?clause]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
retractallM1

"not tested

retractall(+?Term) retracts all occurences of a clause with a given head ?Term from the default logic repository"

retractall(&term) if 
	nonvar(?term),getRepository(?repository),getEnv(?env,?),[?repository
	retractAll: (&term predicateInEnv: ?env startAt: nil)
	multiplicity: &term multiplicity]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
reverseM2

"tested on 28/08/2001

reverse(+?List,+-?ReversedList)
	 reverse(-?List,+?ReversedList)
	 reverses a given list. At most one argument may be uninstantiated."

reverse(?List,?ReversedList) if 
	var(?List),var(?ReversedList),error(['reverse/2 was called with both arguments variable!!']).
reverse(?List,?ReversedList) if 
	reverse(?List,<>,?ReversedList)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
reverseM3

reverse(<>,?ReversedList,?ReversedList).
reverse(<?Head|?Tail>,?ReversedSoFar,?ReversedList) if 
	reverse(?Tail,<?Head|?ReversedSoFar>,?ReversedList)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
sameElementsM2

"tested on 05-07-2001

Returns whether two lists have the same elements. 
	The order of the elements is not important"

sameElements(?list1,?list2) if 
	list(?list1),list(?list2),subSetOf(?list1,?list2),subSetOf(?list2,?list1).
sameElements(?list1,?list2) if 
	or(and(var(?list1),list(?list2)),and(list(?list1),var(?list2))),equals(?list1,?list2)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
startsAndEndsWithM3

"CASE 1: ?Start and ?End are known"

startsAndEndsWith(?AString,+?Start,+?End) if 
	string(?Start),string(?End),equals(?AString,[?Start speciesAppend: ?End]).
"CASE 2: ?AString and ?Start are known"

startsAndEndsWith(+?AString,+?Start,-?End) if 
	string(?AString),string(?Start),[?Start , '*' match: ?AString],equals(?End,[?AString
	speciesCopyFrom: ?Start size + 1
	to: ?AString size]).
"CASE 3: ?AString and ?End are known"

startsAndEndsWith(+?AString,-?Start,+?End) if 
	string(?AString),string(?End),['*' ,? End match: ?AString],equals(?Start,[?AString
	speciesCopyFrom: 1
	to: ?AString size - ?End size])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
startsWithM2

"tested on 28/08/2001

startsWith(+?String,+?Prefix) checks whether a given ?String starts with some ?Prefix
	 Both arguments are supposed to be instantiated upon calling this predicate. Warning:
	 the predicate is case-INsensitive, in other words it makes no distinction between capitals
	 and non-capitals when comparing strings.

Implementation note: the reason for the case-insensitivity has to do with the lower-level
	 Smalltalk primitive (i.e. #match:) that was used to implement this predicate. It was no
	 deliberate design decision for the predicate."

startsWith(?AString,?APrefix) if 
	or(var(?AString),var(?APrefix)),error(['startsWith/2 was called with one or both arguments variable!!']).
startsWith(?AString,?APrefix) if 
	[?APrefix , '*' match: ?AString]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringM1

"tested on 06/09/2001

string(+-?Term) succeeds if, and only if, ?Term is a Smalltalk string or symbol."

string(&Term) if 
	atom(&Term),[?Term isString]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringOrAtomM1

"not tested

stringOrAtom(+-?Something) checks whether ?Something is a Smalltalk string or QSOUL atom.

Implementation note: in QSOUL, strings are considered as a special kind of atoms."

stringOrAtom(?StringOrAtom) if 
	atom(StringOrAtom)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringOrAtomSplitM4

"stringOrAtomSplit(+?StringOrAtom,+?SubStringOrAtom,+-?BeforeString,+-?AfterString) is the same as stringSplit/4, but
also works for atoms. It computes the part of StringOrAtom that can be found before and after a given substring (or atom).
(More than one solution is possible if SubStringOrAtom occurs more than one time in StringOrAtom).
USAGE NOTE: The variables StringOrAtom and SubStringOrAtom are not allowed to be unbound variables when this
predicate is called.

Implementation note: in fact we do not need to handle the case for atoms separately. Apparently this case is already
handled automatically due to an automatic conversions of Smalltalk atoms to Smalltalk strings. So we can just use the
stringSplit predicate instead. In fact, this predicate stringOrAtomSplit is thus not really needed anymore, but is still here
because it might be called by other predicates."

stringOrAtomSplit(?StringOrAtom,?SubStringOrAtom,?BeforeString,?AfterString) if 
	stringSplit(?StringOrAtom,?SubStringOrAtom,?BeforeString,?AfterString)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringOrAtomStartsWithM3

"stringOrAtomStartsWith(+?StringOrAtom, ?Start, ?After) is the same as startsAndEndsWith/3, but
also works for atoms. It checks whether a ?StringOrAtom starts with a substring or atom ?Start,
and puts the remainder of the ?StringOrAtom in a string ?After.
USAGE NOTE: The variable StringOrAtom is not allowed to be an unbound variable when this predicate is called.

Implementation note: in fact we do not need to handle the case for atoms separately. Apparently this case is already
handled automatically due to an automatic conversions of Smalltalk atoms to Smalltalk strings. So we can just use the
startsAndEndsWith predicate instead. In fact, this predicate stringOrAtomStartsWith is thus not really needed anymore, but is still here
because it might be called by other predicates."

stringOrAtomStartsWith(?StringOrAtom,?Start,?After) if 
	startsAndEndsWith(?StringOrAtom,?Start,?After)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringOrAtomToCharsM2

"tested

stringOrAtomToChars(+-?StringOrAtom, +-?CharList) transforms a ?StringOrAtom to a ?CharList."

stringOrAtomToChars(?StringOrAtom,?CharList) if 
	stringOrAtom(?StringOrAtom),equals(?collection,[| collection newCollection |
collection := ?StringOrAtom asOrderedCollection.
newCollection := collection copyEmpty.
collection do: [:each | newCollection add: each asSymbol].
newCollection]),listAsCollection(?CharList,?collection)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringSplitM4

"tested on 28/08/2001

stringSplit(+?String,+?SubString,+-?Before,+-?After) computes the part of ?String that
	 can be found ?Before and ?After a given ?Substring. 
	 More than one solution is possible if ?SubString occurs more than one time in ?String.
	 The variables ?String and ?SubString are not allowed to be unbound variables when
	 this predicate is called. Both ?Before and ?After can either be variable or not.
	 ?SubString is supposed to be non-empty, otherwise the predicate will fail.

Implementation note: The predicate is implemented by using a piece of Smalltalk code
	 which generates all possible positions in the string where the substring is located."

stringSplit(?AString,?SubString,?Before,?After) if 
	or(var(?AString),var(?SubString)),error(['stringSplit/4 was called with first and/or second argument variable!!']).
stringSplit(?AString,?SubString,?Before,?After) if 
	member(?Index,[| index allIndexes |
index := 0.
allIndexes := OrderedCollection new.
[index := ?AString
	findString: ?SubString
	startingAt: index + 1.
index == 0] whileFalse: [allIndexes add: index].
allIndexes]),equals(?Before,[?AString
	speciesCopyFrom: 1
	to: ?Index - 1]),equals(?After,[?AString
	speciesCopyFrom: ?Index + ?SubString size
	to: ?AString size])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
stringToCharsM2

"stringToChars(+-?String, +-?CharList) transforms a ?String to a ?CharList."

stringToChars(?String,?CharList) if 
	string(?String),stringOrAtomToChars(?String,?CharList)! !

!DataHandlingLayer methodsFor: 'collections' stamp: 'sp 24/10/11 15:26'!
subSetOfM2

subSetOf(+?Set1,+?Set2) if 
	forall(member(?El,?Set1),member(?El,?Set2))! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
subStructureListM4

"Auxiliary predicate for constructing a compound term from an instantiated list."

subStructureList(?coll,<>,<>,?) if 
	equals(?coll,[OrderedCollection new]).
subStructureList(?coll,<?car|?cdr>,<?carPointer|?varRest>,?count) if 
	subStructureList(?collection,?cdr,?varRest,[?count + 1]),envLookup(?car,?carPointer),equals(?coll,[?collection
	addFirst: ((Variable name: 'temp') setAddress: ?count);
	yourself])! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
sublistOfM2

sublistOf(?sublist,?list) if 
	append(?sublist,?,?list).
sublistOf(?sublist,<?|?rest>) if 
	sublistOf(?sublist,?rest)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
symbolM1

"tested on 06/09/2001

symbol(+-?Term) succeeds if and only if ?Term is a Smalltalk symbol."

symbol(&Term) if 
	atom(&Term),[?Term isSymbol]! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
tailM2

"tested on 22/08/2001

tail(+-?RestList, +?List) unifies ?RestList with ?List without its first element.
	 ?RestList can either be instantiated or not. ?List must be instantiated, although
	 it may be only partially instantiated."

tail(?Rest,<?First|?Rest>)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
unionM3

"reimplemented by Tom Mens to make it more consistent with the definitions of the oher set handling operators

tested on 22/08/2001

union(+?Set1,+?Set2,+-?Union) computes the ?Union of two sets ?Set1 and ?Set2.
	 Both ?Set1 and ?Set2 are supposed to be instantiated. ?Union can either be instantiated
	 or not. The order of the elements in the ?Union is the order of which the elements
	 occur in ?Set1 and ?Set2 respectively.

Note: the implementation below is a rather slow one, because noDups/2 is very slow.

Old implementation was:
union(?Set1,?Set2,?Union) if
	append(?Set1,?Set2,?UnionWithDups),
	noDups(?UnionWithDups,?Union).

"

union(?Set1,?Set2,?Union) if 
	findall(?El,or(includes(?El,?Set1),includes(?El,?Set2)),?UnionWithDups),noDups(?UnionWithDups,?Union)! !

!DataHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:58'!
varM1

"tested on 21/08/2001

var(+-?Term) succeeds if, and only if, ?Term is an unbound variable.
	 An unbound variable is one which has not been bound to another term
	 (other than another uninstantiated variable)."

var(&Term) if 
	[&Term isKindOf: SoulFactory current makeVariable]! !

LogicPrimitives subclass: #ErrorHandlingLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!ErrorHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 10/25/2011 14:38'!
errorM1

"Displays an error and immediately stops interpretation

SUnit test written (Roel, Jan 28, 2002)"

error(?errorString) if 
	[SoulRuntimeException signal: ('SOUL >> ' , ?errorString)]! !

!ErrorHandlingLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 10/28/2011 10:28'!
inspectTermM1

"SUnit test written (Roel, Jan 28, 2002)"

inspectTerm(?aTerm) if 
	[?aTerm inspect.
	self halt.
	true]! !

LogicPrimitives subclass: #IOLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
newlineM1

"tested on 08/07/2001

newline/0 takes the cursor to the next line on the Transcript.
	It takes a dummy argument because PROLOG does not allow 0-ary predicates."

newline(?) if 
	[Transcript cr.
true]! !

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
writeLnLstM1

"tested on 29/08/2001

writeLnLst(?List) writes each of the elements of a list on the Transcript,
	 each one separated by a carriage return."

writeLnLst(?List) if 
	foreach(?List,writeLn)! !

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
writeLnM1

"tested on 08/07/2001

writeLn(?Something) writes the string representation of ?Something on
	 the Transcript, followed by a carriage return."

writeLn(?Something) if 
	write(?Something),newline(?)! !

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
writeLstLnM1

"tested on 29/08/2001

writeLstLn(?List) writes each of the elements of a list on the Transcript, one after the other,
	 and then go to a new line."

writeLstLn(?List) if 
	writeLst(?List),newline(?)! !

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
writeLstM1

"tested on 29/08/2001

writeLst(?List) writes each of the elements of a list on the Transcript, one after the other."

writeLst(?List) if 
	foreach(?List,write)! !

!IOLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
writeM1

"tested on 08/07/2001

write(?Something) writes the string representation of ?Something on the Transcript."

write(?Something) if 
	[Transcript show: ?Something asString.
true]! !

LogicPrimitives subclass: #LogicProgramControlLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!LogicProgramControlLayer methodsFor: 'SLG resolution' stamp: 'AndyKellens 11/3/2011 10:28'!
answerM3

answer(?id,?call,?delayed) if 
	[SoulFactory answer: ?call forCID: ?id using: ?delayed.
false]! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
applyM2

"apply(?PredicateName,?ArgumentList) applies the predicate with name ?PredicateName to a
	 given ?ArgumentList. For example, apply(foo,<bar,zork>) is equivalent to calling foo(bar,zork)."

apply(?PredicateName,?ArgumentList) if 
	equalsStructureList(?Query,<?PredicateName|?ArgumentList>),?Query! !

!LogicProgramControlLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
caseQ

"case is a predicate that can take an arbitrary list of parameters of the form
	 cond(?Condition,?Action). It works as follows: the ?Action corresponding to the
	 first succesful ?Condition is executed. The remaining conditions and actions
	 are then ignored (in other words, only one case can be fired)."

case@(<cond(?Condition,&Action)|?Cases>) if 
	one(or(and(?Condition,do(&Action)),apply(case,?Cases)))! !

!LogicProgramControlLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
constrainM2

"tested

constrain/2 does a generate and check operation, in other words a kind of domain check. For example:
		constrain(?c, [Smalltalk allClasses])
	If ?c has a value, then it is ensured that this is a Smalltalk class.   
	if ?c is a variable, values for ?c are generated"

constrain(?term,?smalltalkTerm) if 
	nonvar(?smalltalkTerm),collectionMember(?generatedTerm,?smalltalkTerm),equals(?term,?generatedTerm)! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
countM2

"count(+?Query,?NumberOfResults) counts how many results there are for ?Query. Note that
the query is supposed to be instantiated upon calling this predicate."

count(+?Query,?NumberOfResults) if 
	findall(dummy,?Query,?list),length(?list,?NumberOfResults)! !

!LogicProgramControlLayer methodsFor: 'bad imperative  predicates' stamp: 'sp 24/10/11 15:26'!
doM1

"do(?Action) does a certain ?Action for its side-effects. Whether are not the action succeeds
	 or fails we don't care, the do-predicate will execute the side-effects and will always succeed."

do(?Action) if 
	succeeds(or(?Action,[true]))! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
exactlyOneM1

"tested on 09-07-2001

exactlyOne(+?Query) tests whether some ?Query produces exactly one result. Note that
	 the query is supposed to be instantiated upon calling this predicate."

exactlyOne(+?Query) if 
	findall(dummy,?Query,<?>),?Query! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
existsM1

"reimplemented

not tested

exists(+?Query) checks whether there exists at least one solution for ?Query.
	?Query is supposed to be instantiated with a valid logic expression."

exists(?Query) if 
	one(?Query)! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
existsM2

"reimplemented

not tested

exists(+?Expression,+?Query) checks whether there exists a solution for ?Expression,
	for which the query ?Query is satisfied. Both ?Expression and ?Query must be
	instantiated with valid logic expressions."

exists(?Expression,?Query) if 
	exists(and(?Expression,?Query))! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
failsM1

"tested

fails(+?Query) succeeds if ?Query fails and succeeds if ?Query fails.
?Query is supposed to be instantiated with a valid logic query."

fails(&Query) if 
	not(&Query)! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'sp 24/10/11 15:26'!
filterDupsM2

filterDups(<>,<>).
filterDups(<?car|?cdr>,?rest) if 
	member(?car,?cdr),filterDups(?cdr,?rest).
filterDups(<?car|?cdr>,<?car|?rest>) if 
	not(member(?car,?cdr)),filterDups(?cdr,?rest)! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'AndyKellens 11/2/2011 09:58'!
findallM3

"tested on 09-07-2001"

findall(&term,&query,?list) if 
	getEnv(?env,?envIdx),envLookup(&query,?queryPointer),envLookup(&term,?termPointer),deify(?list,[| ruleSelector holdcallStack oldFrame results hisIndex copier |
ruleSelector := SoulFactory current makeRuleSelector new.
holdcallStack := ?env callStack.
oldFrame := ?env currentFrame.
ruleSelector evalTermApplication: ?queryPointer inEnv: ?env.
results := OrderedCollection new.
[ruleSelector next == false]
	whileFalse:
		[results
			add:
				(?termPointer term soulUp
					soulDownIn: ?env
					startAt: ?termPointer envIndex) soulUp].
?env callStack: holdcallStack.
?env currentFrame: oldFrame.
copier := CopyingVisitor new.
(SoulFactory current makeList termSequence: (TermSequence terms: results))
	accept: copier])! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'sp 24/10/11 15:26'!
forallM1

"forall(?query) checks whether all possible evaluation paths for ?query succeed.
	 If the ?query itself fails, then forall/1 also fails as there are no evaluation paths for
	?query that have succeeded."

forall(?query) if 
	exists(?query),forall(?query,[true])! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'sp 24/10/11 15:26'!
forallM2

forall(?query,&test) if 
	not(?query,not(&test))! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'sp 24/10/11 15:26'!
forallM3

"tested 03/04/2002

implemented by KM - 03/04/2002

forall(?query, ?test, ?failures) is related to forall/2, but also returns the elements from ?query 
	that failed the ?test. These are returned in the ?failures list. In fact, it is more like a findall/3 in
	the sense that it accumulates a list of all solutions of ?query that fail the ?test.
	Note: The regular forall stops with the first element it encounters that does 
		not satisfy ?test. This forall/3 does not: it will check for all results 
		of query too whether they satisfy ?test or not.

For example:	forall(	member(?e,<[1], [2], [3]>),	equals(?e, [2]),	?L)
	 yields:	?L -> < equals([1],[2]), equals([3],[2])>
	 because [1] and [3] failed the ?test but satisfied the ?query"

forall(?query,?test,?failures) if 
	findall(?test,and(?query,not(?test)),?failures)! !

!LogicProgramControlLayer methodsFor: 'iterators' stamp: 'sp 24/10/11 15:26'!
foreachM2

"tested on 29/08/2001

foreach/2

foreach(+?List, +?Predicate) applies the ?Predicate one by one to each of the
	 elements of a list ?List. Both the ?Predicate and the ?List are supposed to be
	 instantiated upon calling foreach/2.

Usage note: This predicate is typically used to apply a predicate with a side
	 effect to each of the elements of a given list. See for example writeLst/1 or
	 writeLnLst/1."

foreach(?List,?Predicate) if 
	list(?List),forall(member(?Item,?List),?Predicate(?Item))! !

!LogicProgramControlLayer methodsFor: 'bad imperative  predicates' stamp: 'sp 24/10/11 15:26'!
ifThenElseM3

"ifThenElse(?Condition,?True,?False) executes the ?True action when the
	 ?Condition is satisfied and executes the ?False action if not."

ifThenElse(?Condition,?True,?False) if 
	case(cond(?Condition,?True),cond([true],?False))! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
nodupM1

"tested on 02/04/2002

nodup(?query) computes ?query without duplicate results.
	 Note that this is not a very efficient predicate."

nodup(?query) if 
	findall(?query,?query,?Results),filterDups(?Results,?ResWithoutDuplicates),member(?query,?ResWithoutDuplicates)! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
oneM1

"tested on 25-10-2001

one(+?Query) returns (only) the first succesful solution for ?Query

?Query must be a valid logic expression (which may include conjunctions
	 and disjunctions)."

one(&query) if 
	&query,!!! !

!LogicProgramControlLayer methodsFor: 'SLG resolution' stamp: 'AndyKellens 11/2/2011 09:58'!
slgM1

slg(?call) if 
	[SoulFactory slg: ?call] contains: ?call! !

!LogicProgramControlLayer methodsFor: 'SLG resolution' stamp: 'AndyKellens 11/2/2011 09:58'!
slgcallM5

slgcall(?id,?vars,?call,?delay,?cont) if 
	[SoulFactory slgcall: ?call forCID: ?id variables: ?vars delay: ?delay
	continuation: ?cont.
false]! !

!LogicProgramControlLayer methodsFor: 'SLG resolution' stamp: 'AndyKellens 11/2/2011 09:58'!
slgnotM5

slgnot(?id,?vars,?call,?delay,?cont) if 
	[SoulFactory slgnot: ?call forCID: ?id variables: ?vars delay: ?delay
	continuation: ?cont.
false]! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
succeedsM1

"tested; to be made more efficient once one/1 has been debugged

succeeds(+?Query) succeeds if ?Query succeeds and fails otherwise.
?Query is supposed to be instantiated with a valid logic query."

succeeds(&Query) if 
	one(&Query)! !

!LogicProgramControlLayer methodsFor: 'evals' stamp: 'sp 24/10/11 15:26'!
xorM2

"tested on 09-07-2001

xor(+?Query1,+?Query2) takes two queries as inputs and succeeds if and only if
	 one of both queries succeeds and the other one fails. Both queries are supposed
	 to be filled in before calling this predicate. xor/2 gives an error when called with
	 one of the arguments variable."

xor(&Query1,&Query2) if 
	or(and(&Query1,not(&Query2)),and(&Query2,not(&Query1)))! !

LogicPrimitives subclass: #SoulReflectionLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'sp 24/10/11 15:26'!
bindRepositoryM2

bindRepository(?variable,?repository) if 
	getRepository(?rep),[?rep bind: ?variable with: ?repository.
true]! !

!SoulReflectionLayer methodsFor: 'testclauses' stamp: 'sp 24/10/11 15:26'!
blaM0

bla if 
	go(a),!!.
bla if 
	test(b)! !

!SoulReflectionLayer methodsFor: 'clauses' stamp: 'sp 24/10/11 15:26'!
clauseM2

clause(?head,?body) if 
	clause(?head,?body,?)! !

!SoulReflectionLayer methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
deifyM2

deify(?var,?term) if 
	getEnv(?env,?),envLookup(?term,?termPointer),envLookup(?var,?varPointer),[| theIndex theTerm fixer |
fixer := FixVisitor new.
?termPointer term isUppedObject
	ifTrue: [theTerm := ?termPointer term soulDownIn: nil startAt: nil]
	ifFalse: [theTerm := ?termPointer term].
theTerm accept: fixer.
theIndex := ?env startUnify: fixer maxIndex + 1.
theTerm
	unifyWith: ?varPointer term
	inEnv: ?env
	myIndex: theIndex
	hisIndex: ?varPointer envIndex
	inSource: false]! !

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'sp 24/10/11 15:26'!
existsInRepositoryM1

"This predicate only works with simple predicates"

existsInRepository(?Head) if 
	getRepository(?repository),equals(?clauses,[| addr clauses mult |
addr := ?repository
	addressForPredicate: ?Head functor smalltalkValue asString.
addr == nil
	ifTrue: [#()]
	ifFalse:
		[mult := ?Head multiplicity.
		clauses := ?repository normalAddressLookup: addr multiplicity: mult.
		clauses collect: [:aClause | aClause conclusion]]]),succeeds(member(?Head,?clauses))! !

!SoulReflectionLayer methodsFor: 'testclauses' stamp: 'sp 24/10/11 15:26'!
fooM0

foo if 
	bla,!!.
foo if 
	test(b)! !

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'sp 24/10/11 15:26'!
getRepositoryM2

getRepository(?variableName,?repository) if 
	getRepository(?rep),equals(?repository,[?rep lookupBindingFor: ?variableName])! !

!SoulReflectionLayer methodsFor: 'testclauses' stamp: 'sp 24/10/11 15:26'!
goM1

go(b)! !

!SoulReflectionLayer methodsFor: 'terms' stamp: 'sp 24/10/11 15:26'!
newVarM1

"Create a new variable on the stack at runtime. This is useful if a new variable needs to be created that was not there at compile time"

newVar(?x) if 
	var(?x),getEnv(?env,?),envLookup(?x,?xpointer),[| startIndex variable |
startIndex := ?env startUnify: 1.
variable := HiddenVariable name: Factory uniqueName.
variable setAddress: 0.
variable
	unifyWith: ?xpointer term
	inEnv: ?env
	myIndex: startIndex
	hisIndex: ?xpointer envIndex
	inSource: true.
true]! !

!SoulReflectionLayer methodsFor: 'terms' stamp: 'AndyKellens 11/2/2011 09:59'!
newVarM2

"Create a new variable on the stack at runtime. This is useful if a new variable needs to be created that was not there at compile time"

newVar(?name,?x) if 
	var(?x),getEnv(?env,?),envLookup(?x,?xpointer),[| startIndex variable |
startIndex := ?env startUnify: 1.
variable := HiddenVariable name: ?name , SoulFactory uniqueCounter asString.
variable setAddress: 0.
variable
	unifyWith: ?xpointer term
	inEnv: ?env
	myIndex: startIndex
	hisIndex: ?xpointer envIndex
	inSource: true.
true]! !

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'AndyKellens 11/2/2011 09:59'!
repositoryM1

"repository(?rep)"

repository(?rep) if 
	member(?rep,[SoulFactory repositoryNames collect: [:name | SoulFactory repository: name]])! !

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'sp 24/10/11 15:26'!
repositoryNameM2

"repositoryName(?rep,?name)"

repositoryName(?rep,?name) if 
	repository(?rep),equals(?name,[?rep name])! !

!SoulReflectionLayer methodsFor: 'repositories' stamp: 'sp 24/10/11 15:26'!
resetRepositoryNamedM1

"resetRepositoryNamed(LogicRoot)

resets a given repository"

resetRepositoryNamed(+?repositoryName) if 
	repositoryName(?rep,?repositoryName),[?rep reset.
true]! !

!SoulReflectionLayer methodsFor: 'testclauses' stamp: 'sp 24/10/11 15:26'!
testM1

test(b)! !

LogicPrimitives subclass: #SymbiosisLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!SymbiosisLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:59'!
collectionMemberM2

collectionMember(?term,+?coll) if 
	getEnv(?env,?),envLookup(?term,?termPointer),[| block hisIndex |
?coll isEmpty
	ifFalse:
		[block := SoulFactory current collectionMemberBlockWithTermPointer:
				?termPointer andEnvironment: ?env.
		hisIndex := ?env startUnify: 0.
		&blockargs
			unifyWith: ?coll asOrderedCollection soulUp
			inEnv: ?env
			myIndex: envIndex
			hisIndex: hisIndex
			inSource: true.
		&resblock
			unifyWith: block soulUp
			inEnv: ?env
			myIndex: envIndex
			hisIndex: hisIndex
			inSource: true.
		true]
	ifTrue: [false]],setResolver(?resblock,?blockargs)! !

!SymbiosisLayer methodsFor: 'soul auto saved' stamp: 'AndyKellens 11/2/2011 09:59'!
isSizeOfXM2

"todo: should eventually end up as alternative for length/2, but unification of an uppedobject with a pair term (in head of lenght) currently raises an error"

?size isSizeOf: +?collection if 
	[?collection isKindOf: Collection],!!,?size equals: [?collection size].
?size isSizeOf: +?collection if 
	length(?collection,?size)! !

!SymbiosisLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
listAsCollectionM2

"listAsCollection(+-?soullist,+-?collection) converts a SOUL list to a Smalltalk collection and vice-versa. 
	WARNING: the list as well as the collection cannot contain free variables!!!!!!!!"

listAsCollection(<>,[OrderedCollection new]) if 
	!!.
listAsCollection(?soullist,?collection) if 
	atom(?collection),findall(?el,member(?el,?collection),?soullist).
listAsCollection(?soullist,?collection) if 
	var(?collection),getEnv(?env,?),envLookup(?soullist,?listPointer),equals(?collection,[?listPointer term
	collectIn: ?env
	startAt: ?listPointer envIndex])! !

!SymbiosisLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
qc2listM2

"Convert a quotedcode to its list representation. The reverse remains to be done"

qc2list(+?qc,?list) if 
	envLookup(?qc,?qcPointer),envLookup(?list,?listPointer),getEnv(?env,?idx),[| theList startIndex |
theList := ?qc asList.
startIndex := ?env startUnify: 0.
?listPointer term
	unifyWith: theList
	inEnv: ?env
	myIndex: ?listPointer envIndex
	hisIndex: ?qcPointer envIndex
	inSource: true]! !

!SymbiosisLayer methodsFor: 'soul auto saved' stamp: 'sp 24/10/11 15:26'!
sourceStringM2

"This predicate extracts a resulting string from a quotedCode or produces a quotedcode from a string "

sourceString(?quotedCode,?SmalltalkString) if 
	quotedCode(?quotedCode),equals(?SmalltalkString,[?quotedCode asString]).
sourceString(?quotedCode,?SmalltalkString) if 
	var(?quotedCode),ground(?SmalltalkString),equals(?quotedCode,[DownedQuotedCode fromString: ?SmalltalkString])! !

LogicStorage subclass: #QuotedParseLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!QuotedParseLayer methodsFor: 'template basics' stamp: 'sp 24/10/11 15:26'!
isListMetaVariableM1

?x isListMetaVariable if 
	symbol(?x),['MetaVar*List' match: ?x]! !

!QuotedParseLayer methodsFor: 'template basics' stamp: 'sp 24/10/11 15:26'!
isMetaVariableM1

?x isMetaVariable if 
	symbol(?x),['MetaVar*' match: ?x]! !

!QuotedParseLayer methodsFor: 'template basics' stamp: 'AndyKellens 11/2/2011 10:00'!
isNewQuotedVariableM1

"Create a new quoted variable. This is useful if a new unique quoted variable needs to be created"

?x isNewQuotedVariable if 
	var(?x),?x equals: [('MetaVar' , SoulFactory uniqueName) asSymbol]! !

!QuotedParseLayer methodsFor: 'template basics' stamp: 'sp 24/10/11 15:26'!
isQuotedVariableM1

"Check if it's a quoted variable."

?x isQuotedVariable if 
	[?x isSymbol],['MetaVar*' match: ?x]! !

!QuotedParseLayer methodsFor: 'template basics' stamp: 'sp 24/10/11 15:26'!
parseM3

"This predicate is necessary and should not be removed. It is called by the typedquotedcodes to parse their contents"

parse(?type,?string,?tree) if 
	scan(?type,?string,?tokens),?type(?tree,?tokens,<>)! !

!QuotedParseLayer methodsFor: 'template conversion' stamp: 'sp 24/10/11 15:26'!
template2queryM2

template2query(?template,?query) if 
	parse(stmethod,?template,?tree),tree2query(?tree,?query)! !

QuotedParseLayer subclass: #SmalltalkParsingLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!SmalltalkParsingLayer commentStamp: '<historical>' prior: 0!
stmethod
!

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
makeKeywordMessage2M3

makeKeywordMessage2(<>,<>,<>).
makeKeywordMessage2(<key(?firstkey,?firstArg)|?keys>,<?firstkey|?resKey>,<?firstArg|?resArgs>) if 
	makeKeywordMessage2(?keys,?resKey,?resArgs)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
makeKeywordMessageM3

makeKeywordMessage(?keywordsAndArguments,?selector,?arguments) if 
	makeKeywordMessage2(?keywordsAndArguments,?keywords,?arguments),makeKeywordSelector(?keywords,?selector)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
makeKeywordSelectorM2

makeKeywordSelector(+?list,?selector) if 
	not(equals(?list,<>)),equals(?selector,[| theSelector |
theSelector := ''.
?list listDo: [:el | theSelector := theSelector , el smalltalkValue].
theSelector asSymbol])! !

!SmalltalkParsingLayer methodsFor: 'template scanning' stamp: 'AndyKellens 3/19/2012 16:41'!
scanM3

scan(?type,?string,?tokens) if 
	[?type asString matchesPattern: 'st*' ignoreCase: false do: nil],deify(?tokens,[QuotedCodeSmalltalkTokenScanner new breakIntoTokens: ?string])! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
soulListvariableM3

soulListvariable(?var,?tokens1,?tokens2) if 
	equals(?tokens1,<xSoulVariable(?varname)|?tokens2>),['*List' match: ?varname],equals(?var,[(Variable name: (?varname allButFirst: 1)) explicitSoulUp])! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
soulvariableM3

soulvariable(?var,?tokens1,?tokens2) if 
	equals(?tokens1,<xSoulVariable(?varname)|?tokens2>),[('*List' match: ?varname) not],equals(?var,[(Variable name: (?varname allButFirst: 1)) explicitSoulUp])! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stAssignmentM3

stAssignment(RBAssignmentNode(RBVariableNode(?name),?expression),?tokens1,?tokens3) if 
	equals(?tokens1,<word(?name),colon(?),binary([#=])|?tokens2>),stExpression(?expression,?tokens2,?tokens3).
stAssignment(RBAssignmentNode(RBVariableNode(?soulvar),?expression),?tokens1,?tokens4) if 
	soulvariable(?soulvar,?tokens1,?tokens2),equals(?tokens2,<colon(?),binary([#=])|?tokens3>),stExpression(?expression,?tokens3,?tokens4)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBasicexpressionM3

stBasicexpression(?result,?tokens1,?tokens2) if 
	stLiteral(?result,?tokens1,?tokens2).
stBasicexpression(?result,?tokens1,?tokens2) if 
	stVariable(?result,?tokens1,?tokens2).
stBasicexpression(?exp,?tokens1,?tokens2) if 
	stBlock(?exp,?tokens1,?tokens2).
stBasicexpression(?var,?tokens1,?tokens2) if 
	soulvariable(?var,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinariesM4

stBinaries(?exp,?result,?tokens1,?tokens3) if 
	stBinary(binary(?message,?arg),?tokens1,?tokens2),stBinaries(RBMessageNode(?exp,?message,<?arg>),?result,?tokens2,?tokens3).
stBinaries(?exp,RBMessageNode(?exp,?message,<?arg>),?tokens1,?tokens2) if 
	stBinary(binary(?message,?arg),?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinaryM3

stBinary(binary(?binary,?expression),?tokens1,?tokens3) if 
	stBinaryterminal(?binary,?tokens1,?tokens2),stUnarymessage(?expression,?tokens2,?tokens3).
stBinary(binary([#-],?num),?tokens1,?tokens2) if 
	equals(?tokens1,<binary([#-]),number(?num)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinarySelectorM3

stBinarySelector(methodHeader(?selector,<?arg>),?tokens1,?tokens2) if 
	stBinarySelector(?selector,?arg,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinarySelectorM4

stBinarySelector(?selector,?arg,?tokens1,?tokens3) if 
	stBinaryterminal(?selector,?tokens1,?tokens2),stWordterminal(?arg,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinarymessageM3

stBinarymessage(?expression,?tokens1,?tokens2) if 
	stUnarymessage(?expression,?tokens1,?tokens2).
stBinarymessage(?result,?tokens1,?tokens3) if 
	stUnarymessage(?expression,?tokens1,?tokens2),stBinaries(?expression,?result,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/21/2012 10:57'!
stBinarymessageWithReceiverM4

stBinarymessageWithReceiver(?expression,?receiver,?tokens1,?tokens2) if 
	stUnarymessageWithReceiver(?expression,?receiver,?tokens1,?tokens2).

stBinarymessageWithReceiver(?result,?receiver,?tokens1,?tokens2) if 
	stBinaries(?receiver,?result,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBinaryterminalM3

stBinaryterminal(?binary,?tokens1,?tokens2) if 
	equals(?tokens1,<binary(?binary)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stBlockArgumentsM3

stBlockArguments(<?arg|?args>,?tokens1,?tokens4) if 
	equals(?tokens1,<colon(?)|?tokens2>),stVariable(?arg,?tokens2,?tokens3),stBlockArguments(?args,?tokens3,?tokens4).
stBlockArguments(<>,?tokens1,?tokens2) if 
	equals(?tokens1,<verticalBar(?)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/20/2012 13:52'!
stBlockM3

stBlock(RBBlockNode(?args,?body),?tokens1,?tokens5) if 
	equals(?tokens1,<leftBracket(?)|?tokens2>),stBlockArguments(?args,?tokens2,?tokens3),stMethodBody(?body,?tokens3,?tokens4),equals(?tokens4,<rightBracket(?)|?tokens5>).

stBlock(RBBlockNode(<>,?body),?tokens1,?tokens4) if 
	equals(?tokens1,<leftBracket(?)|?tokens2>),stMethodBody(?body,?tokens2,?tokens3),equals(?tokens3,<rightBracket(?)|?tokens4>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/22/2012 10:56'!
stCascadedMessagesM4

stCascadedMessages(<?keyWordMessage>,?receiver,?tokens1,?tokens3) if 
	stsemicolon(?,?tokens1,?tokens2),stKeywordmessageWithReceiver(?keyWordMessage,?receiver,?tokens2,?tokens3),RBMessageNode(?,?,?) equals: ?keyWordMessage.

stCascadedMessages(<?keyWordMessage|?cascadedMessages>,?receiver,?tokens1,?tokens4) if 
	stsemicolon(?,?tokens1,?tokens2),soulvariable(?keyWordMessage,?tokens2,?tokens3),stCascadedMessages(?cascadedMessages,?receiver,?tokens3,?tokens4).

stCascadedMessages(<?keyWordMessage|?cascadedMessages>,?receiver,?tokens1,?tokens4) if 
	stsemicolon(?,?tokens1,?tokens2),stKeywordmessageWithReceiver(?keyWordMessage,?receiver,?tokens2,?tokens3),RBMessageNode(?,?,?) equals: ?keyWordMessage,stCascadedMessages(?cascadedMessages,?receiver,?tokens3,?tokens4).

stCascadedMessages(<?keyWordMessage,?cascadedMessages>,?receiver,?tokens1,?tokens4) if 
	stsemicolon(?,?tokens1,?tokens2),soulvariable(?keyWordMessage,?tokens2,?tokens3),stCascadedMessages(?cascadedMessages,?receiver,?tokens3,?tokens4),not(list(?cascadedMessages)).

stCascadedMessages(<?keyWordMessage,?cascadedMessages>,?receiver,?tokens1,?tokens4) if 
	stsemicolon(?,?tokens1,?tokens2),stKeywordmessageWithReceiver(?keyWordMessage,?receiver,?tokens2,?tokens3),RBMessageNode(?,?,?) equals: ?keyWordMessage,stCascadedMessages(?cascadedMessages,?receiver,?tokens3,?tokens4),not(list(?cascadedMessages)).

stCascadedMessages(?keyWordMessage,?receiver,?tokens1,?tokens3) if 
	stsemicolon(?,?tokens1,?tokens2),soulvariable(?keyWordMessage,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/22/2012 10:02'!
stCascademessageM3

stCascademessage(?keyWordMessage,?tokens1,?tokens2) if 
	stKeywordmessage(?keyWordMessage,?tokens1,?tokens2).

stCascademessage(RBCascadeNode(<?keyWordMessage|?cascadedMessages>),?tokens1,?tokens3) if 
	stKeywordmessage(?keyWordMessage,?tokens1,?tokens2),RBMessageNode(?receiver,?,?) equals: ?keyWordMessage,stCascadedMessages(?cascadedMessages,?receiver,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stExpressionM3

stExpression(?exp,?tokens1,?tokens2) if 
	stAssignment(?exp,?tokens1,?tokens2).
stExpression(?exp,?tokens1,?tokens2) if 
	stCascademessage(?exp,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/20/2012 15:30'!
stKeywordSelector2M4

stKeywordSelector2(<?selector|?nextSelectors>,<?arg|?nextArgs>,?tokens1,?tokens4) if 
	stKeywordterminal(?selector,?tokens1,?tokens2),stVariable(?arg,?tokens2,?tokens3),stKeywordSelector2(?nextSelectors,?nextArgs,?tokens3,?tokens4).

stKeywordSelector2(<?selector>,<?arg>,?tokens1,?tokens3) if 
	stKeywordterminal(?selector,?tokens1,?tokens2),stVariable(?arg,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stKeywordSelectorM3

stKeywordSelector(methodHeader(?selector,?args),?tokens1,?tokens3) if 
	stKeywordSelector2(?selectorList,?args,?tokens1,?tokens2),and({makeKeywordSelector(?selectorList,?selector)},equals(?tokens2,?tokens3))! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stKeywordmessageM3

stKeywordmessage(?binaryMessage,?tokens1,?tokens2) if 
	stBinarymessage(?binaryMessage,?tokens1,?tokens2).
stKeywordmessage(RBMessageNode(?binaryMessage,?selector,?arguments),?tokens1,?tokens4) if 
	stBinarymessage(?binaryMessage,?tokens1,?tokens2),stKeywords(?keys,?tokens2,?tokens3),and({makeKeywordMessage(?keys,?selector,?arguments)},equals(?tokens3,?tokens4)).
stKeywordmessage(RBMessageNode(?receiver,?var,<?argumentexpression>),?tokens1,?tokens4) if 
	stBinarymessage(?receiver,?tokens1,?tokens2),soulvariable(?var,?tokens2,?tokens3),stBinarymessage(?argumentexpression,?tokens3,?tokens4)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/21/2012 10:54'!
stKeywordmessageWithReceiverM4

stKeywordmessageWithReceiver(?binaryMessage,?receiver,?tokens1,?tokens2) if 
	stBinarymessageWithReceiver(?binaryMessage,?receiver,?tokens1,?tokens2).

stKeywordmessageWithReceiver(RBMessageNode(?receiver,?selector,?arguments),?receiver,?tokens1,?tokens3) if 
	stKeywords(?keys,?tokens1,?tokens2),and({makeKeywordMessage(?keys,?selector,?arguments)},equals(?tokens2,?tokens3)).

stKeywordmessageWithReceiver(RBMessageNode(?receiver,?var,<?argumentexpression>),?receiver,?tokens1,?tokens3) if 
	soulvariable(?var,?tokens1,?tokens2),stBinarymessage(?argumentexpression,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stKeywordsM3

stKeywords(<key(?keyword,?expression)>,?tokens1,?tokens3) if 
	stKeywordterminal(?keyword,?tokens1,?tokens2),stBinarymessage(?expression,?tokens2,?tokens3).
stKeywords(<key(?keyword,?expression)|?keywords>,?tokens1,?tokens4) if 
	stKeywordterminal(?keyword,?tokens1,?tokens2),stBinarymessage(?expression,?tokens2,?tokens3),stKeywords(?keywords,?tokens3,?tokens4)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stKeywordterminalM3

stKeywordterminal(?word,?tokens1,?tokens2) if 
	equals(?tokens1,<keyword(?word)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stLiteralM3

stLiteral(RBLiteralValueNode(true),?tokens1,?tokens2) if 
	equals(?tokens1,<word(true)|?tokens2>).
stLiteral(RBLiteralValueNode(false),?tokens1,?tokens2) if 
	equals(?tokens1,<word(false)|?tokens2>).
stLiteral(RBLiteralValueNode(nil),?tokens1,?tokens2) if 
	equals(?tokens1,<word(nil)|?tokens2>).
stLiteral(RBLiteralValueNode(?num),?tokens1,?tokens2) if 
	equals(?tokens1,<number(?num)|?tokens2>).
stLiteral(RBLiteralValueNode(?char),?tokens1,?tokens2) if 
	equals(?tokens1,<character(?char)|?tokens2>).
stLiteral(RBLiteralValueNode(?num),?tokens1,?tokens2) if 
	equals(?tokens1,<binary([#-]),number(?num)|?tokens2>).
stLiteral(RBLiteralValueNode(?string),?tokens1,?tokens2) if 
	equals(?tokens1,<string(?string)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stMethodBodyM3

stMethodBody(RBSequenceNode(?temporaries,?statements),?tokens1,?tokens3) if 
	stTemporaries(?temporaries,?tokens1,?tokens2),stStatementList(?statements,?tokens2,?tokens3).
stMethodBody(RBSequenceNode(<>,?statements),?tokens1,?tokens2) if 
	stStatementList(?statements,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stMethodHeaderM3

stMethodHeader(methodHeader(?selector,<>),?tokens1,?tokens2) if 
	stUnarySelector(?selector,?tokens1,?tokens2).
stMethodHeader(methodHeader(?selector,?args),?tokens1,?tokens2) if 
	stBinarySelector(methodHeader(?selector,?args),?tokens1,?tokens2).
stMethodHeader(methodHeader(?selector,?args),?tokens1,?tokens2) if 
	stKeywordSelector(methodHeader(?selector,?args),?tokens1,?tokens2).
stMethodHeader(methodHeader(?selector,?args),?tokens1,?tokens2) if 
	stTemplateSelector(methodHeader(?selector,?args),?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stMethodM3

stMethod(RBMethodNode(?selector,?arguments,?body),?tokens1,?tokens3) if 
	stMethodHeader(methodHeader(?selector,?arguments),?tokens1,?tokens2),stMethodBody(?body,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stReturnM3

stReturn(RBReturnNode(?expression),?tokens1,?tokens3) if 
	equals(?tokens1,<upArrow(?)|?tokens2>),stExpression(?expression,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stStatementList2M3

stStatementList2(<?statement|?nextStatements>,?tokens1,?tokens4) if 
	stStatement(?statement,?tokens1,?tokens2),equals(?tokens2,<period(?)|?tokens3>),stStatementList2(?nextStatements,?tokens3,?tokens4).
stStatementList2(<?statement>,?tokens1,?tokens2) if 
	stStatement(?statement,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stStatementListM3

stStatementList(?var,?tokens1,?tokens2) if 
	soulvariable(?var,?tokens1,?tokens2).
stStatementList(?statements,?tokens1,?tokens2) if 
	stStatementList2(?statements,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stStatementM3

stStatement(?statement,?tokens1,?tokens2) if 
	stReturn(?statement,?tokens1,?tokens2).
stStatement(?statement,?tokens1,?tokens2) if 
	stExpression(?statement,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stTemplateSelectorArgumentListM3

stTemplateSelectorArgumentList(<?arg>,?tokens1,?tokens2) if 
	stWordterminal(?arg,?tokens1,?tokens2).
stTemplateSelectorArgumentList(<?arg|?rest>,?tokens1,?tokens4) if 
	stWordterminal(?arg,?tokens1,?tokens2),equals(?tokens2,<binary([#,])|?tokens3>),stTemplateSelectorArgumentList(?rest,?tokens3,?tokens4).
stTemplateSelectorArgumentList(?arg,?tokens1,?tokens2) if 
	soulListvariable(?arg,?tokens1,?tokens2).
stTemplateSelectorArgumentList(<?arg>,?tokens1,?tokens2) if 
	stVariable(?arg,?tokens1,?tokens2).
stTemplateSelectorArgumentList(<?arg|?rest>,?tokens1,?tokens4) if 
	stVariable(?arg,?tokens1,?tokens2),equals(?tokens2,<binary([#,])|?tokens3>),stTemplateSelectorArgumentList(?rest,?tokens3,?tokens4)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stTemplateSelectorM3

stTemplateSelector(methodHeader(?selector,?args),?tokens1,?tokens5) if 
	stWordterminal(?selector,?tokens1,?tokens2),equals(?tokens2,<leftParenthesis(?)|?tokens3>),stTemplateSelectorArgumentList(?args,?tokens3,?tokens4),equals(?tokens4,<rightParenthesis(?)|?tokens5>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stTemporaries2M3

stTemporaries2(<?temp|?nextList>,?tokens1,?tokens3) if 
	stWordterminal(?temp,?tokens1,?tokens2),stTemporaries2(?nextList,?tokens2,?tokens3).
stTemporaries2(<>,?tokens1,?tokens2) if 
	equals(?tokens1,<verticalBar(?)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stTemporariesM3

stTemporaries(?temporariesList,?tokens1,?tokens2) if 
	soulvariable(?temporariesList,?tokens1,?tokens2).
stTemporaries(?temporariesList,?tokens1,?tokens3) if 
	equals(?tokens1,<verticalBar(?)|?tokens2>),stTemporaries2(?temporariesList,?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stUnariesM4

stUnaries(?exp,?result,?tokens1,?tokens3) if 
	stWordterminal(?message,?tokens1,?tokens2),stUnaries(RBMessageNode(?exp,?message,<>),?result,?tokens2,?tokens3).
stUnaries(?exp,RBMessageNode(?exp,?message,<>),?tokens1,?tokens2) if 
	stWordterminal(?message,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stUnarySelectorM3

stUnarySelector(?selector,?tokens1,?tokens2) if 
	stWordterminal(?selector,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stUnarymessageM3

stUnarymessage(?expression,?tokens1,?tokens2) if 
	stBasicexpression(?expression,?tokens1,?tokens2).
stUnarymessage(?result,?tokens1,?tokens3) if 
	stBasicexpression(?expression,?tokens1,?tokens2),stUnaries(?expression,?result,?tokens2,?tokens3).
stUnarymessage(RBMessageNode(?exp,?selector,?args),?tokens1,?tokens3) if 
	stBasicexpression(?exp,?tokens1,?tokens2),stTemplateSelector(methodHeader(?selector,?args),?tokens2,?tokens3)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'AndyKellens 3/21/2012 10:58'!
stUnarymessageWithReceiverM4

stUnarymessageWithReceiver(?expression,?receiver,?tokens1,?tokens2) if 
	stBasicexpression(?expression,?tokens1,?tokens2).

stUnarymessageWithReceiver(?result,?receiver,?tokens1,?tokens2) if 
	stUnaries(?receiver,?result,?tokens1,?tokens2).

stUnarymessageWithReceiver(RBMessageNode(?receiver,?selector,?args),?receiver,?tokens1,?tokens2) if 
	stTemplateSelector(methodHeader(?selector,?args),?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stVariableM3

stVariable(RBVariableNode(?name),?tokens1,?tokens2) if 
	stWordterminal(?name,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stWordterminalM3

stWordterminal(?word,?tokens1,?tokens2) if 
	equals(?tokens1,<word(?word)|?tokens2>).
stWordterminal(?var,?tokens1,?tokens2) if 
	soulvariable(?var,?tokens1,?tokens2)! !

!SmalltalkParsingLayer methodsFor: 'template compilation' stamp: 'sp 24/10/11 15:26'!
statementsUnderInterpretationXcompilesToXforResultXM4

<> statementsUnderInterpretation: ? compilesTo: <> forResult: ?.
<?firstTemplateStatement|?restTemplateStatements> statementsUnderInterpretation: ? compilesTo: <?firstTemplateStatement foundIn: ?statements withRest: ?restStatements|?query> forResult: ?statements if 
	not(?firstTemplateStatement equals: RBMessageNode(?,?,?args),?args contains: RBBlockNode(?,?)),?restStatements isNewQuotedVariable,?restTemplateStatements statementsUnderInterpretation: ? compilesTo: ?query forResult: ?restStatements.
"?args contains: RBBlockNode(?,?),"

<?firstTemplateStatement|?restTemplateStatements> statementsUnderInterpretation: ? compilesTo: <?firstTemplateStatement isMessageSendIn: ?statements withRest: ?restStatements|?query> forResult: ?statements if 
	?firstTemplateStatement equals: RBMessageNode(?,?,?args),?restStatements isNewQuotedVariable,?restTemplateStatements statementsUnderInterpretation: ? compilesTo: ?query forResult: ?restStatements.
?statements statementsUnderInterpretation: ? compilesTo: <?statements equals: ?statements2> forResult: ?statements2 if 
	?statements isQuotedVariable! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stperiodM3

stperiod(?period,?tokens1,?tokens2) if 
	equals(?tokens1,<period(?period)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stsemicolonM3

stsemicolon(semicolon(?x),?tokens1,?tokens2) if 
	equals(?tokens1,<semicolon(?x)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template parsing' stamp: 'sp 24/10/11 15:26'!
stwordM3

stword(?word,?tokens1,?tokens2) if 
	equals(?tokens1,<word(?word)|?tokens2>)! !

!SmalltalkParsingLayer methodsFor: 'template compilation' stamp: 'AndyKellens 3/20/2012 10:58'!
templateUnderInterpretationXcompilesToXforResultXM4

RBMethodNode(?selector,?args,?templatebody) templateUnderInterpretation: ?interpretation compilesTo: <?result isMethodWithName: ?selector inClass: ?class,RBMethodNode(?selector,?args,?body) isParseTreeOfMethod: ?result|?bodyquery> forResult: ?result if 
	?result isNewQuotedVariable,?class isNewQuotedVariable,?body isNewQuotedVariable,?templatebody templateUnderInterpretation: ?interpretation compilesTo: ?bodyquery forResult: ?body.

RBSequenceNode(?templatetemps,?templatestatements) templateUnderInterpretation: ? compilesTo: <?result equals: RBSequenceNode(?temps,?statements),sublistOf(?templatetemps,?temps)|?statementsQuery> forResult: ?result if 
	?temps isNewQuotedVariable,?statements isNewQuotedVariable,?templatestatements statementsUnderInterpretation: ? compilesTo: ?statementsQuery forResult: ?statements! !

QuotedParseLayer subclass: #SmalltalkTemplateRuntimeLayer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SOUL-LogicPrimitives'!

!SmalltalkTemplateRuntimeLayer methodsFor: 'template runtime' stamp: 'sp 24/10/11 15:26'!
foundInXwithRestXM3

+?statement foundIn: <?statement|?next> withRest: ?next.
?statement foundIn: <?first|?next> withRest: ?nextStatements if 
	not(?statement equals: ?first),?statement foundIn: ?next withRest: ?nextStatements! !

!SmalltalkTemplateRuntimeLayer methodsFor: 'template runtime' stamp: 'sp 24/10/11 15:26'!
isMessageSendInXwithRestXM3

RBMessageNode(?receiver,?selector,?arguments) isMessageSendIn: <RBMessageNode(?receiver,?selector,?matchedArguments)|?next> withRest: ?next if 
	?matchedArguments contains: RBBlockNode(?,?),?matchedArguments matchesArguments: ?arguments.
RBMessageNode(?receiver,?selector,?arguments) isMessageSendIn: <RBMessageNode(?receiver,?selector,?arguments)|?next> withRest: ?next if 
	not(?arguments contains: RBBlockNode(?,?)).
?statement isMessageSendIn: <RBReturnNode(?statement)|?next> withRest: ?next.
?statement isMessageSendIn: <?first|?next> withRest: ?nextStatements if 
	?statement isMessageSendIn: ?next withRest: ?nextStatements! !

!SmalltalkTemplateRuntimeLayer methodsFor: 'template runtime' stamp: 'sp 24/10/11 15:26'!
matchesArgumentsXM2

<> matchesArguments: <>.
<?blockArgMatch|?restMatchedArguments> matchesArguments: <?blockArg|?restArgs> if 
	?blockArgMatch equals: RBBlockNode(?t,RBSequenceNode(?,?statements)),?blockArg equals: RBBlockNode(?t,RBSequenceNode(?,?matchStatements)),?matchStatements matchesStatements: ?statements,?restMatchedArguments matchesArguments: ?restArgs.
<?argument|?restMatchedArguments> matchesArguments: <?argument|?restArgs> if 
	?restMatchedArguments matchesArguments: ?restArgs! !

!SmalltalkTemplateRuntimeLayer methodsFor: 'template runtime' stamp: 'sp 24/10/11 15:26'!
matchesStatementsXM2

<> matchesStatements: <>.
<?match|?matchingStatements> matchesStatements: ?statements if 
	?match foundIn: ?statements withRest: ?rest,?matchingStatements matchesStatements: ?rest! !
